/***************************************************************************
                          m_internal_loop.h  -  description
                             -------------------
    begin                : Fri Apr 12 2002
    copyright            : (C) 2002 by Mirela Andronescu
    email                : andrones@cs.ubc.ca
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef M_INTERNAL_LOOP_H
#define M_INTERNAL_LOOP_H

#include "constants.h"
#include "structs.h"

class m_energy_matrix;

class m_internal_loop
{
    public:

        friend class m_energy_matrix;

        m_internal_loop (int *seq, int num_b, int *b, int length);
        // The constructor

        ~m_internal_loop ();
        // The destructor

        void set_energy_matrix (m_energy_matrix *V) { this->V = V; }
        // Set local energy matrix to V

        PARAMTYPE compute_energy (int i, int j);
        // compute MFE of the structure closed by the internal loop closed at (i,j)

        PARAMTYPE get_valid_energy (int i, int j, int ip, int jp);
        // return FE of the internal loop closed at (i,j,ip,jp)
        // redundant with get_energy

        static PARAMTYPE get_energy (int i, int j, int ip, int jp, int *sequence, int num_b, int *b);
        // return FE of the internal loop closed at (i,j,ip,jp)
        
        static PARAMTYPE get_enthalpy (int i, int j, int ip, int jp, int *sequence, int num_b, int *b);
        // return enthalpy of the internal loop closed at (i,j,ip,jp)
        
    private:
        int *sequence;                 // the entire sequence for which we compute the energy
        int seqlen;                     // sequence length
        m_energy_matrix *V;               // a pointer to the free energy matrix V   

        // MF
        int *b;
        int num_b;
        
};

#include "m_energy_matrix.h"
#endif
